javax.media.j3d

## Class RotPosScalePathInterpolator

- java.lang.Object
- - javax.media.j3d.SceneGraphObject
  - - javax.media.j3d.Node
    - - javax.media.j3d.Leaf
      - - javax.media.j3d.Behavior
        - - javax.media.j3d.Interpolator
          - - javax.media.j3d.TransformInterpolator
            - - javax.media.j3d.PathInterpolator
              - - javax.media.j3d.RotPosScalePathInterpolator

-     public class RotPosScalePathInterpolator
      extends PathInterpolator

  RotPosScalePathInterpolation behavior. This class defines a behavior that varies the rotational, translational, and scale components of its target TransformGroup by linearly interpolating among a series of predefined knot/position, knot/orientation, and knot/scale pairs (using the value generated by the specified Alpha object). The interpolated position, orientation, and scale are used to generate a transform in the local coordinate system of this interpolator. The first knot must have a value of 0.0. The last knot must have a value of 1.0. An intermediate knot with index k must have a value strictly greater than any knot with index less than k.

- - ### Field Summary

    - ### Fields inherited from class javax.media.j3d.PathInterpolator

      `currentInterpolationValue, currentKnotIndex`

    - ### Fields inherited from class javax.media.j3d.TransformInterpolator

      `axis, axisInverse, target`

    - ### Fields inherited from class javax.media.j3d.Interpolator

      `defaultWakeupCriterion`

    - ### Fields inherited from class javax.media.j3d.Node

      `ALLOW_AUTO_COMPUTE_BOUNDS_READ, ALLOW_AUTO_COMPUTE_BOUNDS_WRITE, ALLOW_BOUNDS_READ, ALLOW_BOUNDS_WRITE, ALLOW_COLLIDABLE_READ, ALLOW_COLLIDABLE_WRITE, ALLOW_LOCAL_TO_VWORLD_READ, ALLOW_LOCALE_READ, ALLOW_PARENT_READ, ALLOW_PICKABLE_READ, ALLOW_PICKABLE_WRITE, ENABLE_COLLISION_REPORTING, ENABLE_PICK_REPORTING`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `RotPosScalePathInterpolator(Alpha alpha, TransformGroup target, Transform3D axisOfTransform, float[] knots, Quat4f[] quats, Point3f[] positions, float[] scales)` Constructs a new RotPosScalePathInterpolator object that varies the rotation, translation, and scale of the target TransformGroup's transform.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `Node` | `cloneNode(boolean forceDuplicate)` Used to create a new instance of the node.
    `void` | `computeTransform(float alphaValue, Transform3D transform)` Computes the new transform for this interpolator for a given alpha value.
    `Transform3D` | `getAxisOfRotPosScale()` Deprecated. As of Java 3D version 1.3, replaced by `TransformInterpolator.geTransformAxis()`
    `void` | `getPosition(int index, Point3f position)` Retrieves the position value at the specified index.
    `void` | `getPositions(Point3f[] positions)` Copies the array of position values from this interpolator into the specified array.
    `void` | `getQuat(int index, Quat4f quat)` Retrieves the quat value at the specified index.
    `void` | `getQuats(Quat4f[] quats)` Copies the array of quaternion values from this interpolator into the specified array.
    `float` | `getScale(int index)` Retrieves the scale at the specified index.
    `void` | `getScales(float[] scales)` Copies the array of scale values from this interpolator into the specified array.
    `void` | `setAxisOfRotPosScale(Transform3D axisOfRotPosScale)` Deprecated. As of Java 3D version 1.3, replaced by `TransformInterpolator.setTransformAxis(Transform3D)`
    `void` | `setPathArrays(float[] knots, Quat4f[] quats, Point3f[] positions, float[] scales)` Replaces the existing arrays of knot values, quaternion values, position values, and scale values with the specified arrays.
    `void` | `setPosition(int index, Point3f position)` Sets the position value at the specified index for this interpolator.
    `void` | `setQuat(int index, Quat4f quat)` Sets the quat value at the specified index for this interpolator.
    `void` | `setScale(int index, float scale)` Sets the scale at the specified index for this interpolator.

    - ### Methods inherited from class javax.media.j3d.PathInterpolator

      `computePathInterpolation, computePathInterpolation, getArrayLengths, getKnot, getKnots, setKnot, setKnots`

    - ### Methods inherited from class javax.media.j3d.TransformInterpolator

      `getTarget, getTransformAxis, processStimulus, setTarget, setTransformAxis, updateNodeReferences`

    - ### Methods inherited from class javax.media.j3d.Interpolator

      `getAlpha, initialize, setAlpha`

    - ### Methods inherited from class javax.media.j3d.Behavior

      `getEnable, getNumSchedulingIntervals, getSchedulingBoundingLeaf, getSchedulingBounds, getSchedulingInterval, getView, getWakeupCondition, postId, setEnable, setSchedulingBoundingLeaf, setSchedulingBounds, setSchedulingInterval, wakeupOn`

    - ### Methods inherited from class javax.media.j3d.Node

      `cloneTree, cloneTree, cloneTree, cloneTree, cloneTree, cloneTree, duplicateNode, getBounds, getBoundsAutoCompute, getCollidable, getLocale, getLocalToVworld, getLocalToVworld, getParent, getPickable, setBounds, setBoundsAutoCompute, setCollidable, setPickable`

    - ### Methods inherited from class javax.media.j3d.SceneGraphObject

      `clearCapability, clearCapabilityIsFrequent, duplicateSceneGraphObject, getCapability, getCapabilityIsFrequent, getName, getUserData, isCompiled, isLive, setCapability, setCapabilityIsFrequent, setName, setUserData, toString`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### RotPosScalePathInterpolator

          public RotPosScalePathInterpolator(Alpha alpha,
                                     TransformGroup target,
                                     Transform3D axisOfTransform,
                                     float[] knots,
                                     Quat4f[] quats,
                                     Point3f[] positions,
                                     float[] scales)

      Constructs a new RotPosScalePathInterpolator object that varies the rotation, translation, and scale of the target TransformGroup's transform.
      Parameters:
        `alpha` - the alpha object for this interpolator.
        `target` - the TransformGroup node affected by this interpolator.
        `axisOfTransform` - the transform that specifies the local coordinate system in which this interpolator operates.
        `knots` - an array of knot values that specify interpolation points.
        `quats` - an array of quaternion values at the knots.
        `positions` - an array of position values at the knots.
        `scales` - an array of scale component values at the knots.
      Throws:
        `java.lang.IllegalArgumentException` - if the lengths of the knots, quats, positions, and scales arrays are not all the same.

  - ### Method Detail

    - #### setQuat

          public void setQuat(int index,
                     Quat4f quat)

      Sets the quat value at the specified index for this interpolator.
      Parameters:
        `index` - the index to be changed
        `quat` - the new quat value at index

    - #### getQuat

          public void getQuat(int index,
                     Quat4f quat)

      Retrieves the quat value at the specified index.
      Parameters:
        `index` - the index of the value requested
        `quat` - returns the interpolator's quat value at the index

    - #### setPosition

          public void setPosition(int index,
                         Point3f position)

      Sets the position value at the specified index for this interpolator.
      Parameters:
        `index` - the index to be changed
        `position` - the new position value at index

    - #### getPosition

          public void getPosition(int index,
                         Point3f position)

      Retrieves the position value at the specified index.
      Parameters:
        `index` - the index of the value requested
        `position` - returns the interpolator's position value at the index

    - #### setScale

          public void setScale(int index,
                      float scale)

      Sets the scale at the specified index for this interpolator.
      Parameters:
        `index` - the index to be changed
        `scale` - the new scale at index

    - #### getScale

          public float getScale(int index)

      Retrieves the scale at the specified index.
      Parameters:
        `index` - the index of the value requested
      Returns:
        the interpolator's scale value at index

    - #### setPathArrays

          public void setPathArrays(float[] knots,
                           Quat4f[] quats,
                           Point3f[] positions,
                           float[] scales)

      Replaces the existing arrays of knot values, quaternion values, position values, and scale values with the specified arrays. The arrays of knots, quats, positions, and scales are copied into this interpolator object.
      Parameters:
        `knots` - a new array of knot values that specify interpolation points.
        `quats` - a new array of quaternion values at the knots.
        `positions` - a new array of position values at the knots.
        `scales` - a new array of scale component values at the knots.
      Throws:
        `java.lang.IllegalArgumentException` - if the lengths of the knots, quats, positions, and scales arrays are not all the same.
      Since:
        Java 3D 1.2

    - #### getQuats

          public void getQuats(Quat4f[] quats)

      Copies the array of quaternion values from this interpolator into the specified array. The array must be large enough to hold all of the quats. The individual array elements must be allocated by the caller.
      Parameters:
        `quats` - array that will receive the quats.
      Since:
        Java 3D 1.2

    - #### getPositions

          public void getPositions(Point3f[] positions)

      Copies the array of position values from this interpolator into the specified array. The array must be large enough to hold all of the positions. The individual array elements must be allocated by the caller.
      Parameters:
        `positions` - array that will receive the positions.
      Since:
        Java 3D 1.2

    - #### getScales

          public void getScales(float[] scales)

      Copies the array of scale values from this interpolator into the specified array. The array must be large enough to hold all of the scales.
      Parameters:
        `scales` - array that will receive the scales.
      Since:
        Java 3D 1.2

    - #### setAxisOfRotPosScale

          public void setAxisOfRotPosScale(Transform3D axisOfRotPosScale)

      Deprecated. As of Java 3D version 1.3, replaced by `TransformInterpolator.setTransformAxis(Transform3D)`

    - #### getAxisOfRotPosScale

          public Transform3D getAxisOfRotPosScale()

      Deprecated. As of Java 3D version 1.3, replaced by `TransformInterpolator.geTransformAxis()`

    - #### computeTransform

          public void computeTransform(float alphaValue,
                              Transform3D transform)

      Computes the new transform for this interpolator for a given alpha value.
      Specified by:
        `computeTransform` in class `TransformInterpolator`
      Parameters:
        `alphaValue` - alpha value between 0.0 and 1.0
        `transform` - object that receives the computed transform for the specified alpha value
      Since:
        Java 3D 1.3

    - #### cloneNode

          public Node cloneNode(boolean forceDuplicate)

      Used to create a new instance of the node. This routine is called by `cloneTree` to duplicate the current node.
      Overrides:
        `cloneNode` in class `Node`
      Parameters:
        `forceDuplicate` - when set to `true`, causes the `duplicateOnCloneTree` flag to be ignored. When `false`, the value of each node's `duplicateOnCloneTree` variable determines whether NodeComponent data is duplicated or copied.
      See Also:
        `Node.cloneTree()`, `Node.cloneNode(boolean)`, `Node.duplicateNode(javax.media.j3d.Node, boolean)`, `NodeComponent.setDuplicateOnCloneTree(boolean)`

Copyright 1996-2008 Sun Microsystems, Inc. All Rights Reserved. Use is subject to license terms.